import org.kxml.kdom.*;
import java.util.*;
/**
 * @author Cosmin
 * 
 */
public class XPathExpression 
{
	String[] locationStepStringsArray;
	XPathLocationStep[] locationStepArray;
	Vector resultNodeSet;
	String expression = null;
	Document document = null;
	
	//should be "//" or "/" or "." (in the future "..")
	String start = null;
	
	XPathExpression (Document document, String expression)
	{
		this.document = document;
		this.expression = expression;
		
		//I do not support function name in the start
		//of an xpath expression
		
		//parse
		if(expression.startsWith("//")) {
			start = "//";
			expression = new String(expression.toCharArray(), 2, expression.length()-2);
		} else if(expression.startsWith("/")) {
			start = "/";
			expression = new String(expression.toCharArray(), 1, expression.length()-1);
		} else if(expression.startsWith("./")) {
			start = ".";
			expression = new String(expression.toCharArray(), 2, expression.length()-2);			
		} else if(expression.startsWith("../")) {
			start = "..";
			expression = new String(expression.toCharArray(), 3, expression.length()-3);
		}
		//System.out.println("Expression "+expression+" start node is "+start);
		
		//because there is no support for StringTokenizer
		//on j2me we remove this
		/*
		StringTokenizer st = new StringTokenizer(expression, "/");
		locationStepStringsArray = new String[st.countTokens()];
		for(int i = 0; i < locationStepStringsArray.length; i++) {
			locationStepStringsArray[i] = st.nextToken();
			System.out.println("location step: "+locationStepStringsArray[i]);
		}
		*/
		
		Vector tmp = new Vector();
		for(int start = 0, end = 0; end < expression.length()-1 && end!=-1; start = end+1) {
			end = expression.indexOf("/", start);
			//System.out.println("start = "+start+" end = "+end);
			tmp.addElement(new String(expression.toCharArray(), start, 
				(end!=-1?end:expression.length())-start));
		}
		locationStepStringsArray = new String[tmp.size()];
		tmp.copyInto(locationStepStringsArray);
		tmp = null;
		
		//the result node set should contain nodes
		//with regard to the starting poing of the xpath expression
		//for now just pass the root of the document
		resultNodeSet = new Vector();
		resultNodeSet.addElement((Node)document);
		
		//start processing every location
		for(int j=0; j < locationStepStringsArray.length; j++)
		{
			String locationStepString = locationStepStringsArray[j];
			XPathLocationStep locationStep = new XPathLocationStep(locationStepString, document);

			resultNodeSet = locationStep.getResult(resultNodeSet);
		}
	}
	
	public Vector getResult()
	{
		return resultNodeSet;
	}
}
