import java.util.Vector;

import org.kxml.Attribute;
import org.kxml.PrefixMap;
import org.kxml.Xml;
import org.kxml.kdom.*;
import java.util.*;
/**
 * @author Cosmin
 *
 */
//TODO: descendant axis doesn't work
//
public class XPathLocationStep 
{
	String axis;
	String nodeTest;
	String nodePrefix;
	String functionName;
	String predicate;
	Document doc;
	
	private void parseLocationStep(String locationStep)
	{
		String next = null;
		
		//todo: should check if the whole xpath expression
		//is parameter to a function
		//todo: optimizations -> next.toCharArray !!!
		next = locationStep;
		int pattIndex = 0;
		//test if we have an axis
		if(next.indexOf("::") == -1)
			if(next.startsWith("@")) {
				axis = "attribute";
				next = new String(next.toCharArray(), 1, next.length()-1);
			} else
				axis = "child";
		else {
			pattIndex = next.indexOf("::");
			if(pattIndex != -1) {
				axis = new String(next.toCharArray(), 0, pattIndex);
				next = new String(next.toCharArray(), pattIndex+2, next.length()-pattIndex-2);
			}
		}
		
		pattIndex = next.indexOf("[");
		if(pattIndex != -1) {
			nodeTest = new String(next.toCharArray(), 0, pattIndex);
			next = new String(next.toCharArray(), pattIndex+1, next.length()-pattIndex-1);
			
			pattIndex = next.lastIndexOf("]");
			//pattIndex shouldn't be -1 in this case
			//maybe we should throw an exception??
			//for now assume that the expression is 
			//formed correctly
			predicate = new String(next.toCharArray(), 0, pattIndex);
		} else nodeTest = next;

		//test for prefix
		if((pattIndex = nodeTest.indexOf(":")) != -1) {
			nodePrefix = new String(nodeTest.toCharArray(), 0, pattIndex);
			nodeTest = new String(nodeTest.toCharArray(), pattIndex+1, next.length()-pattIndex-1);
		}
										
		//System.out.println("this partial location: "+locationStep+" is parsed into");
		//System.out.println("functionName="+functionName+" axis="+axis+" nodeTest="+nodeTest+" predicate="+predicate);
	}		
			
	public XPathLocationStep(String locationStep, Document doc)
	{
		parseLocationStep(locationStep);
		
		this.doc = doc;
	
	}//constructor

	/**the contextNodeSet is made of nodes
	* that are instances of Element
	*/
	public Vector getResult(Vector contextNodeSet)
	{
		Vector outputNodeSet = new Vector();
		int nodeCount = contextNodeSet.size();
		int i = 0;
		
		if(axis.equals("child") || axis.equals("descendant")) {
			for(i = 0; i < nodeCount; i++) {
				Node node = (Node)contextNodeSet.elementAt(i);
				int childCount = node.getChildCount();
				
				for(int j = 0; j < childCount; j++) {					
					if(node.getType(j) == Xml.ELEMENT) {
						Node childNode = (Node)node.getChild(j);
						String childName = childNode.getName();
						
						String prefix = null;
						if(nodePrefix != null) {
							Element element = (Element)childNode;
							String namespace = element.getNamespace();
							PrefixMap map = element.getPrefixMap();
							prefix = map.getPrefix(namespace);
						}
						
						if(nodeTest.equals("*") ||
							nodeTest.equals(childName) ||
							nodeTest.equals("node()")) {
							if(((nodePrefix != null) && (nodePrefix.equals(prefix))) ||
								(nodePrefix == null))
								outputNodeSet.addElement(childNode);
						} else if(nodeTest.equals("text()"))
							outputNodeSet.addElement(childNode.getText());
					
						if(axis.equals("descendant")) {
							Vector descendants = null;
							descendants = getMatchingDescendants(childNode);

							for(int k = 0; k < descendants.size(); k++)
								outputNodeSet.addElement(descendants.elementAt(k));
						}
					} else if(node.getType(j) == Xml.TEXT) {
						if(nodeTest.equals("text()"))
							outputNodeSet.addElement(node.getText(j));
					}
				}
			}
		}

		if(axis.equals("attribute")) {
			for(i = 0; i < nodeCount; i++) {
				Node n = (Node)contextNodeSet.elementAt(i);

				if(n instanceof Element) {
					Attribute attr = ((Element)n).getAttribute(nodeTest);
					if(attr != null)
						outputNodeSet.add(attr.getValue());
				}
			}
		}
		
		//other axes go here
		Predicate predicateEvaluator = 
			new Predicate(outputNodeSet, predicate, doc); 
		outputNodeSet = predicateEvaluator.getResult();
		return outputNodeSet;
	}
		

	private Vector getMatchingDescendants(Node node)
	{
		Vector matchingDescendants = new Vector();
		int childCount = node.getChildCount();
		
		for(int j = 0; j < childCount; j++) {			
			//this is were we test if the
			//node test part of our xpath expression
			//matches this node
			if(node.getType(j) == Xml.ELEMENT) {
				Node childNode = (Node)node.getChild(j);
				String name = ((Element)childNode).getName();
				if(nodeTest.equals("*") ||
					nodeTest.equals(name))
					matchingDescendants.addElement(node);
				
				Node[] moreDescendants = null;
				
				Vector tmp = getMatchingDescendants(childNode);
				
				moreDescendants = new Node[tmp.size()];
				tmp.copyInto(moreDescendants);
				tmp = null;
				
				for(int i = 0; i < moreDescendants.length; i++)
					matchingDescendants.addElement(moreDescendants[i]);
			}
		}
		return matchingDescendants;
	}
}
